package com.cxytiandi.pattern.builder;

/**
 * @作者 尹吉欢
 * @个人微信 jihuan900
 * @微信公众号 猿天地
 * @GitHub https://github.com/yinjihuan
 * @作者介绍 http://cxytiandi.com/about
 * @时间 2021-02-06 20:35
 */
public class CreateUser2Context {

    private String username;

    private int age;

    public static CreateUser2ContextBuilder builder() {
        return new CreateUser2ContextBuilder();
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public static class CreateUser2ContextBuilder{
        private String username;
        private int age;

        public CreateUser2ContextBuilder username(String username) {
            this.username = username;
            return this;
        }

        public CreateUser2ContextBuilder age(int age) {
            this.age = age;
            return this;
        }

        public CreateUser2Context build() {
            CreateUser2Context createUser2Context = new CreateUser2Context();
            createUser2Context.setUsername(this.username);
            createUser2Context.setAge(this.age);
            return createUser2Context;
        }
    }
}
