package com.cxytiandi.pattern.handler.ch2;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;

/**
 * @作者 尹吉欢
 * @个人微信 jihuan900
 * @微信公众号 猿天地
 * @GitHub https://github.com/yinjihuan
 * @作者介绍 http://cxytiandi.com/about
 * @时间 2021-02-06 21:14
 */
public class FilterTest {
    public static void main(String[] args) {
        OrderRequest orderRequest = OrderRequest.builder().skuId(1).price(new BigDecimal(0)).count(5).build();

        BusinessFilter<OrderRequest> priceFilter = new OrderBuyPriceFilter();
        BusinessFilter<OrderRequest> countFilter = new OrderBuyCountFilter();
        List<BusinessFilter<OrderRequest>> businessFilters = Arrays.asList(priceFilter, countFilter);
        for (BusinessFilter filter : businessFilters) {
            boolean result = filter.execute(orderRequest);
            if (result == false) {
                break;
            }
        }
    }
}
