package com.cxytiandi.pattern.handler.ch2;

import java.math.BigDecimal;

/**
 * @作者 尹吉欢
 * @个人微信 jihuan900
 * @微信公众号 猿天地
 * @GitHub https://github.com/yinjihuan
 * @作者介绍 http://cxytiandi.com/about
 * @时间 2021-02-06 21:09
 */
public class OrderBuyPriceFilter implements BusinessFilter<OrderRequest> {

    @Override
    public boolean execute(OrderRequest orderRequest) {
        if (orderRequest.getPrice().compareTo(BigDecimal.ZERO) < 1) {
           System.out.println("价格必须大于0");
           return false;
        }
        return true;
    }
}
