package com.cxytiandi.pattern.observer.guava;

import com.cxytiandi.pattern.observer.spring.CreateOrderEvent;
import com.google.common.eventbus.AsyncEventBus;
import com.google.common.eventbus.EventBus;
import com.google.common.eventbus.Subscribe;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import java.util.concurrent.Executors;

/**
 * @作者 尹吉欢
 * @个人微信 jihuan900
 * @微信公众号 猿天地
 * @GitHub https://github.com/yinjihuan
 * @作者介绍 http://cxytiandi.com/about
 * @时间 2021-05-23 10:56
 */
@Slf4j
@Service
public class OrderServiceByGuavaEvent {

    //EventBus eventBus = new EventBus();
   EventBus eventBus = new AsyncEventBus("default", Executors.newFixedThreadPool(10));

    @PostConstruct
    public void init() {
        eventBus.register(this);
    }

    public void create() {
        //创建.....
        log.info("publish event，thread {}", Thread.currentThread().getName());
        CreateOrderEvent event = new CreateOrderEvent();
        event.setOrderNo("10034232311212");
        eventBus.post(event);
    }

    @Subscribe
    public void onMessage(CreateOrderEvent event) {
        log.info("onMessage {}，thread {}", event.getOrderNo(), Thread.currentThread().getName());
    }


    @Subscribe
    public void onMessage2(CreateOrderEvent event) {
        log.info("onMessage2 {}，thread {}", event.getOrderNo(), Thread.currentThread().getName());
    }
}
