package com.cxytiandi.pattern.observer.spring;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Service;

/**
 * @作者 尹吉欢
 * @个人微信 jihuan900
 * @微信公众号 猿天地
 * @GitHub https://github.com/yinjihuan
 * @作者介绍 http://cxytiandi.com/about
 * @时间 2021-05-23 10:56
 */
@Slf4j
@Service
public class OrderServiceByEvent {

    @Autowired
    private ApplicationContext applicationContext;

    public void create() {
        //创建.....
        log.info("publish event，thread {}", Thread.currentThread().getName());
        CreateOrderEvent event = new CreateOrderEvent();
        event.setOrderNo("10034232311212");
        applicationContext.publishEvent(event);
    }

    @Async
    @EventListener
    public void onMessage(CreateOrderEvent event) {
        log.info("onMessage {}，thread {}", event.getOrderNo(),Thread.currentThread().getName());
    }

    @Async
    @EventListener
    public void onMessage2(CreateOrderEvent event) {
        log.info("onMessage2 {}，thread {}", event.getOrderNo(),Thread.currentThread().getName());
    }
}
